//
//  ConfigurationTerminalViewController.swift
//  EADemo
//

import UIKit
import ExternalAccessory


class ConfigurationTerminalViewController: UIViewController {

    var sessionController:  SessionController!
    var accessory:          EAAccessory?
   
    @IBOutlet weak var textView: UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    override func viewWillAppear(_ animated: Bool) {
        
        NotificationCenter.default.addObserver(self, selector: #selector(sessionDataReceived), name: NSNotification.Name(rawValue: wsDataReceivedNotification), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(accessoryDidDisconnect), name: NSNotification.Name.EAAccessoryDidDisconnect, object: nil)
        
        sessionController = SessionController.sharedController
        accessory = sessionController._accessory
        _ = sessionController.openSession()

        super.viewWillAppear(animated)
    }
    
    
    override func viewWillDisappear(_ animated: Bool) {

        NotificationCenter.default.removeObserver(self, name: NSNotification.Name(rawValue: wsDataReceivedNotification), object: nil)
        NotificationCenter.default.removeObserver(self, name: NSNotification.Name.EAAccessoryDidDisconnect, object: nil)
        
        sessionController.closeSession()
        
        super.viewWillDisappear(animated)
    }

    func printsample(){

        let woosim : WSEncoder = WSEncoder()
        let printData : NSMutableData = NSMutableData()
        let line: NSString = "--------------------------------"
        printData.append(woosim.clearPrinterBuffer())
        printData.append(woosim.setFontSize(FONTSIZE_A))
        //2inch printer: 384dot, 3inch printer: 576dot, 4inch printer: 832dot
        printData.append(woosim.setPrintableAreaWidthInStandardMode(384))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_CENTER))
        printData.append(woosim.setTextSizeWith(TEXTWIDTH_1, with: TEXTHEIGHT_2))
        printData.append(woosim.setTextBold(true))
        printData.append(woosim.add("Sales Receipt", encoding: String.Encoding.ascii.rawValue))
        
        printData.append(woosim.shiftAbsolutePosition(296))
        printData.append(woosim.createBarcodeQRCode("http://woosim.com", dataEncoding: String.Encoding.ascii.rawValue, symbolVersion: 0, ecLevel: 0x51, moduleSize: 3))
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.printAndFeedNLine(inStandardMode: 2))
        
        
        printData.append(woosim.setTextSizeWith(TEXTWIDTH_1, with: TEXTHEIGHT_1))
        printData.append(woosim.setTextBold(false))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        
        printData.append(woosim.add("MERCHANT NAME", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("woosim coffee", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add("MASTER", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("Gil-dong Hong", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add("ADDRESS", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("#60, Sandan-ro 388", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.add("beon-gil, Galsan-myeon,", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.add("Hongseong-gun, Chung", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.add("cheongnam-do, S.Korea", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add("HELP DESK", encoding: String.Encoding.ascii.rawValue))
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("(+82-2)2081-4822", encoding: String.Encoding.ascii.rawValue))
 
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add(line as String?, encoding: String.Encoding.ascii.rawValue))
        
        printData.append(woosim.add("Product", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.shiftAbsolutePosition(184))
        printData.append(woosim.add("Sale", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("Price", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add(line as String?, encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printAndFeedNLine(inStandardMode: 1))

        printData.append(woosim.add("Cafe mocha", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.shiftAbsolutePosition(176))
        printData.append(woosim.add("2", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("7.5$", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add("Cafe latte", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.shiftAbsolutePosition(176))
        printData.append(woosim.add("1", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("7.0$", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
       
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
        printData.append(woosim.add("Cappucino", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.shiftAbsolutePosition(176))
        printData.append(woosim.add("1", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("7.0$", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())


        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
 
        printData.append(woosim.add(line as String?, encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.add("Total", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_RIGHT))
        printData.append(woosim.add("29.0$", encoding: String.Encoding.ascii.rawValue))
        printData.append(woosim.printDataInStandardMode())
        printData.append(woosim.printAndFeedNLine(inStandardMode: 2))
        printData.append(woosim.setTextAlignInStandardMode(ALIGN_LEFT))
      
        
        
        sessionController.writeData(data: printData as Data)
     
        let printImgData : NSMutableData = NSMutableData()
        //print image
        let currentBundle = Bundle.main
        let path = currentBundle.path(forResource: "logo", ofType: "bmp")
        let img = UIImage(contentsOfFile: path!)
        let cgimg = img?.cgImage
        
        printImgData.append(woosim.printCompressedImage(inStandardMode: cgimg, withDithering: false))
        printImgData.append(woosim.printImageInStandardMode())
        

        //1D Barcode
        let date : Date = Date()
        let dateFormatter = DateFormatter()
        dateFormatter.dateFormat = "MMddyyyyHHmmssZ"
        let todaysDate = dateFormatter.string(from: date)
        
        printImgData.append(woosim.shiftAbsolutePosition(25))
        printImgData.append(woosim.createBarcode(todaysDate, barcodeType: BARCODE_CODE128))
        printImgData.append(woosim.printDataInStandardMode())
        printImgData.append(woosim.printAndFeedNLine(inStandardMode: 5))
        
        sessionController.writeData(data: printImgData as Data)
    }
    
    // MARK: - Session Updates
    @objc func sessionDataReceived(notification: NSNotification) {
        
        let rcvData:NSMutableData = NSMutableData()
        
        while (self.sessionController.readBytesAvailable()>0){
            let bytesAvailable = self.sessionController.readBytesAvailable()
            let data = self.sessionController.readData(bytesToRead: bytesAvailable)
            if (data.count > 0) {
                rcvData.append(data)
            }
        }
        
        print(String(decoding: rcvData, as: UTF8.self));
        self.textView.text = String(decoding: rcvData, as:UTF8.self)
  
    }
    
    // MARK: - EAAccessory Disconnection
    @objc func accessoryDidDisconnect(notification: NSNotification) {
        
        if navigationController?.topViewController == self {
            let disconnectedAccessory = notification.userInfo![EAAccessoryKey]
            if (disconnectedAccessory as! EAAccessory).connectionID == accessory?.connectionID {
                dismiss(animated: true, completion: nil)
            }
        }
    }

    
    @IBAction func onPrintSample(_ sender: Any) {
        //configureAccessoryWithString(string: stringCommandTextField.text ?? "", stringType: commandTypes.string)
        self.printsample()
    }

    @IBAction func onGetStatus(_ sender: Any) {
        let woosim = WSEncoder()
        let printData : NSMutableData = NSMutableData()
        printData.append(woosim.requestPrinterName())
        self.sessionController.writeData(data: printData as Data)
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
